#include <QtGui>

#include "dialog.h"
#include "woman_file.h"

newPersonDialog::newPersonDialog(QWidget *parent) : QDialog(parent)
{

    ///////////////////////////WIDGET DEFINITIONS/////////////////

    labelName     = new QLabel(tr("&İsminiz:"));
    dateLabel     = new QLabel(tr("&Son Dönem Başlangıcını Seçin"));
    durationLabel = new QLabel(tr("Dönem Zamanı"));
    periotLabel   = new QLabel(tr("Periyot"));

    nameLine =  new QLineEdit;

    okButton = new QPushButton("Tamam");
    cancelButton = new QPushButton("Vazgeç");

    calendar = new QCalendarWidget;

    durationSpin = new QSpinBox;
    periotSpin = new QSpinBox;

    ///////////////////////END OF WIDGET DEFINITION///////////////
    //////////////////////////////////////////////////////////////
    ///////////////////////////INITIALIZE WIDGET/////////////////

    labelName->setBuddy(nameLine);
    dateLabel->setBuddy(calendar);

    nameLine->setMaxLength(50);

    durationSpin->setRange(1, 31);
    periotSpin->setRange(1, 31);

    okButton->setDefault(true);
    okButton->setEnabled(false);

    ///////////////////////END OF INITIALIZE WIDGET/////////////
    ///////////////////////////////////////////////////////////
    ///////////////////////SETTING SIGNALS/////////////////////

    connect(nameLine, SIGNAL(textChanged(const QString &)), this, SLOT(enableOkButton(const QString &)));

    connect(cancelButton, SIGNAL(clicked()), this, SLOT(close()));

    connect(okButton, SIGNAL(clicked()), this, SLOT(saveAndCallAccept()));

    ////////////////////EN OF SETTING SIGNALS///////////////////
    ///////////////////////////////////////////////////////////
    ////////////////////SETTING LAYOUTS///////////////////////

    QHBoxLayout *hblo = new QHBoxLayout;
    hblo->addWidget(labelName);
    hblo->addWidget(nameLine);

    QVBoxLayout *vblo = new QVBoxLayout;    
    vblo->addLayout(hblo);
    vblo->addSpacing(15);

    vblo->addWidget(dateLabel);
    vblo ->addWidget(calendar);
    vblo->addSpacing(15);

    QHBoxLayout *hblo2 = new QHBoxLayout;
    hblo2->addWidget(periotLabel);
    hblo2->addSpacing(5);
    hblo2->addWidget(durationLabel);
    vblo->addLayout(hblo2);

    QHBoxLayout *hblo3 = new QHBoxLayout;
    hblo3->addWidget(periotSpin);
    hblo3->addSpacing(5);
    hblo3->addWidget(durationSpin);
    vblo->addLayout(hblo3);

    QHBoxLayout *mhblo = new QHBoxLayout;
    mhblo->addLayout(vblo);
    mhblo->addSpacing(15);

    QVBoxLayout *vblo2 = new QVBoxLayout;
    vblo2->addWidget(okButton);
    vblo2->addWidget(cancelButton);

    mhblo->addLayout(vblo2);

    setLayout(mhblo);
    this->setWindowTitle("Please Fill Your Infos");

    ////////////////////EN OF SETTING LAYOUTS///////////////////
    ////////////////////////////////////////////////////////////
}

/*****************************************************************/

void newPersonDialog::enableOkButton(const QString &text) const
{
    okButton->setEnabled(!text.isEmpty());
}

/*****************************************************************/

void newPersonDialog::saveAndCallAccept(void)
{
    QDate lastDate = calendar->selectedDate();

    saveNewPerson(lastDate.day(), lastDate.month(), lastDate.year(), durationSpin->value(), periotSpin->value(), nameLine->text());
    this->accept();
}

/*****************************************************************/











