#ifndef MAINWINDOW_H
#define MAINWINDOW_H


#include <QMainWindow>

class QLabel;
class QLineEdit;
class QPushButton;
class QSpinBox;
class QCalendarWidget;
class Woman;


class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);

protected:
    void createToolBar(void);
    void createMainWindow(void);

private slots:
    void closeEvent(QCloseEvent *event);
    bool newPerson(void);
    void save(void);
    void showNextDate(void);
    void saveTmpDate(void);
    void removePerson(void);
    void saveAsDefault(void);
    void lock_unlock(void);
    void changedSpinBoxes(void);
    bool openPerson(void);
    void showPreviousDate(void);
    void callSetTheme(void);


private:
    bool changedInfo;
    Woman *woman;

    ///////////////WIDGETS////////////////////////
    QLabel *labelName;
    QLabel *label;
    QLabel *dateLabel;
    QLabel *durationLabel;
    QLabel *periotLabel;

    QSpinBox *spinDay;
    QSpinBox *spinMonth;
    QSpinBox *spinYear;
    QSpinBox *spinDuration;
    QSpinBox *spinPeriot;

    QPushButton *lock_unlockButton;
    QPushButton *showPreviousDateButton;
    QPushButton *showNextDateButton;

    QCalendarWidget *calendar;

    ///////////////////MENU//////////////////////
    QMenu *fileMenuBar;
    QMenu *editMenuBar;
    QMenu *themeMenuBar;    
    QMenu *othersTheme;

    //FileMenuBar Actions
    QAction *openPersonAction;
    QAction *newPersonAction;
    QAction *removePersonAction;
    QAction *closeAction;

    //EditMenuBar Actions
    QAction *saveChangeAction;
    QAction *saveAsDefaultPersonAction;
    QAction *saveTmpDateAction;

    //ThemeMenuBar Actions
    QAction *defaultTheme;
    QAction *redTheme;
    QAction *yellowTheme;
    QAction *blueTheme;
    QAction *pinkTheme;

    //private functions
    void createActions(void);
    void createMenu(void);
    void setOpeningWindow();
    void setSpinBoxesValue(void);
    void setTheme(int no = -1);

    //Styles
    QString styleButton;
    QString styleLabel;
    QString styleMenu;
    QString styleMenuBar;
    QString styleSpinbox;
    QString styleMain;


};

#endif // MAINWINDOW_H
