#include <QFile>
#include <QTextStream>
#include <QDir>
#include <iostream>
#include <QMessageBox>
using namespace std;

#include <woman_file.h>
#include "woman.h"

/*****************************************************************/

void openingControl(QString userHome, Woman *woman)
{
    QString path = userHome;

    path.append("/.woman");

    QDir dir(path);

    if(!dir.exists()){
        if(dir.mkpath(path)){
            path.append("/config");

            QFile file(path);

            if(!file.open(QFile::WriteOnly | QFile::Truncate)){
                cout << "açılamadı " << endl;
                return;
            }

            QTextStream stream(&file);
            stream.setCodec("UTF-8");
            stream << 0 << endl << 0;

            file.close();

            path = userHome;
            path.append("/.woman/user_and_ids");
            file.setFileName(path);

            if(!file.open(QFile::WriteOnly | QFile::Truncate)){
                cout << "2. dosya açılamadı " << endl;
                return;
            }

            stream.setDevice(&file);
            stream << 0 << endl;
            file.close();
            woman->set_id(0);

            path = userHome;
            path.append("/.woman/theme");
            file.setFileName(path);

            if(!file.open(QFile::WriteOnly | QFile::Truncate)){
                cout << "3. dosya açılamadı " << endl;
                return;
            }

            stream.setDevice(&file);
            stream << 0;
            file.close();

        }

    }
    else{
        int controlCount;
        path.append("/config");
        QFile control(path);
        control.open(QFile::ReadOnly);
        QTextStream streamc(&control);

        streamc >> controlCount >> controlCount;
        if(controlCount == 0){
            control.close();
            woman->set_id(0);
            return;
        }
        else
            control.close();

        path.clear();
        path.insert(0, userHome);
        path.append("/.woman/config");

        QFile file(path);
        int default_person;

        if(!file.open(QFile::ReadOnly)){
            cout << "config dosyası okunamadı" << endl;
            return;
        }

        QTextStream stream(&file);
        stream >> default_person;

        if(default_person){
            woman->set_id(default_person);  //setting woman id
            woman->defaultPerson = true;
            return;
        }
        else{
            woman->defaultPerson = false;
        }

        woman->set_id(-1);
    }

}

/*****************************************************************/

void saveNewPerson(int day, int month, int year, int duration, int periot, QString name, QString userHome)
{
    QString path = userHome;
    QString buffer;
    int lastID;

    path.append("/.woman/user_and_ids");

    QFile file(path);

    file.open(QFile::ReadOnly);

    QTextStream stream(&file);

    stream >> lastID;
    ++lastID;

    buffer = stream.readAll();

    file.close();
    file.open(QFile::WriteOnly | QFile::Truncate);
    QTextStream stream2(&file);

    stream2 << lastID;
    stream2 << buffer;
    stream2 << name << ":" << lastID << endl;
    stream2.flush();


     path = userHome;
     path.append("/.woman/");

     char id[] = "\0\0\0\0\0\0\0\0";
     sprintf(id, "%d", lastID);
     path.append(id);
     file.close();

     QFile lastUser(path);
     QTextStream stream3(&lastUser);
     lastUser.open(QFile::WriteOnly | QFile::Truncate);

     stream3 << name << endl << day << endl << month << endl << year << endl << periot << endl << duration;
     stream3.flush();
     lastUser.close();

     QString message;

     message.insert(0, "ID numaranız: ");
     message.append(id);
     message.append("\nBundan sonraki girişleriniz bu numara üzerinden yapılacak. Unutmayınız...");

     path.clear();
     path.insert(0, QDir::homePath());
     path.append("/.woman/config");
     file.setFileName(path);

     file.open(QFile::ReadOnly);
     int defaultID, personCount;

     QTextStream stream4(&file);
     stream4 >> defaultID >> personCount;
     buffer = stream4.readAll();
     file.close();

     file.open(QFile::WriteOnly | QFile::Truncate);
     QTextStream stream5(&file);
     stream5 << defaultID << endl << (personCount+1) << buffer;
     file.close();

     QMessageBox::warning(NULL, "Uyarı", message, QMessageBox::Ok);

}

/*****************************************************************/

int getLastID(QString path)
{
    int lastID;
    path.append("/.woman/user_and_ids");

    QFile file(path);
    QTextStream stream(&file);
    file.open(QFile::ReadOnly);

    stream >> lastID;
    file.close();

    return lastID;
}

/*****************************************************************/

bool verifyID(const int &id)
{
    char idc[] = "\0\0\0\0\0";
    sprintf(idc, "%d", id);

    QString path= QDir::homePath();
    path.append("/.woman/");
    path.append(idc);

    QFile file(path);


    if(file.open(QFile::ReadOnly)){
        file.close();
        return true;
    }

    return false;
}

/*****************************************************************/

void removePersonFile(Woman *woman)
{
    char idc[] = "\0\0\0\0\0";
    sprintf(idc, "%d", woman->get_id());
    QString path = QDir::homePath();
    QString buffer;
    path.append("/.woman/");
    path.append(idc);

    if(QFile::remove(path))
        cout << "silindi" << endl;
    else
        cout << "silinemedi" << endl;

    path.clear();
    path.insert(0, QDir::homePath());
    path.append("/.woman/config");
    QFile file(path);

    file.open(QFile::ReadOnly);
    int defaultID, personCount;

    QTextStream stream4(&file);
    stream4 >> defaultID >> personCount;
    buffer = stream4.readAll();
    file.close();

    file.open(QFile::WriteOnly | QFile::Truncate);
    QTextStream stream5(&file);
    if(woman->defaultPerson){
        stream5 << 0 << endl;
        woman->defaultPerson = false;
    }
    else
        stream5 << defaultID << endl;

     stream5 << (personCount-1) << buffer;

    file.close();


}

/*****************************************************************/

int checkIsTherePerson(void)
{
    int default_person;
    QString path = QDir::homePath();
    path.append("/.woman/config");
    QFile file(path);
    file.open(QFile::ReadOnly);

    QTextStream stream(&file);
    stream >> default_person;

    file.close();
    return default_person;
}

/*****************************************************************/

void setPersonDefault(int const &id)
{
    int default_person;
    QString buffer;
    QString path = QDir::homePath();
    path.append("/.woman/config");
    QFile file(path);
    file.open(QFile::ReadOnly);
    QTextStream stream(&file);
    stream >> default_person;
    buffer = stream.readAll();

    file.close();

    file.open(QFile::WriteOnly | QFile::Truncate);
    QTextStream stream2(&file);
    stream << id;
    stream << buffer;
    file.close();

}

/*****************************************************************/

bool savePerson(int id, int day, int month, int year, int duration, int periot, QString name, QString userHome)
{
    QString path = userHome;
    path.append("/.woman/");
    char idc[] = "\0\0\0\0";
    sprintf(idc, "%d", id);
    path.append(idc);
    QFile file(path);
    if(!file.open(QFile::WriteOnly | QFile::Truncate)){
        cout << "Açılmaz ha b u" << endl;
        return false;
    }
    QTextStream stream(&file);
    stream << name << endl << day << endl << month << endl << year << endl << periot << endl << duration;
    file.close();
    return true;

}

/*****************************************************************/

bool get_setTheme(int &no, bool &ok)
{

    QString path = QDir::homePath();
    path.append("/.woman/theme");
    QFile file(path);
    QTextStream stream(&file);

    if(ok){
        if(!file.open(QFile::ReadOnly))
            return false;

        stream >> no;
        file.close();
        return true;
    }
    else{
        if(!file.open(QFile::ReadWrite | QFile::Truncate))
            return false;

        stream << no;
        file.close();
        return true;
    }
}







